﻿Imports System
Imports System.Text
Imports System.Text.Encoding
Imports Microsoft.VisualBasic
Imports System.IO
Imports System.Drawing
Imports System.Drawing.Imaging
Public Class Form1

    Private Declare Function Image2PDFOCR_SinglePage_GetTextInfo Lib "i2pocrsdk.dll" (ByVal lpszPDFFile As String, ByRef lpChars As Integer, ByVal lpszOptions As String) As Integer
    Private Declare Sub Image2PDFOCR_SinglePage_FreeTextInfo Lib "i2pocrsdk.dll" (ByRef lpChars As Byte)
    Private Declare Function Image2PDFOCR_SinglePage_CreatePDF Lib "i2pocrsdk.dll" (ByVal lpszInPDFFile As String, ByRef lpChars As Byte, ByVal nCharCount As Integer, ByVal lpszOutPDFFile As String, ByVal lpszOptions As String) As Integer
    Private Declare Function Image2PDFOCR_PDFCmd Lib "i2pocrsdk.dll" (ByVal lpszOptions As String) As Integer
    Private Declare Function Image2PDFOCR_CreateSearchablePDF Lib "i2pocrsdk.dll" (ByVal lpTIFOrPDFFile As String, ByVal lpOutputFile As String, ByVal lpOptions As String) As Integer

    Private Declare Function Image2PDFOCR_GetTextHandle Lib "i2pocrsdk.dll" (ByVal lpszTIFOrPDFFile As String, ByVal lpszOptions As String) As Integer
    Private Declare Function Image2PDFOCR_GetOCRedPageCount Lib "i2pocrsdk.dll" (ByVal hImage2PDFData As Integer) As Integer
    Private Declare Function Image2PDFOCR_GetTextInfo Lib "i2pocrsdk.dll" (ByVal hImage2PDFData As Integer, ByVal nPage As Integer, ByRef lpOutTextInfo As Integer) As Integer
    Private Declare Function Image2PDFOCR_SetTextInfo Lib "i2pocrsdk.dll" (ByVal hImage2PDFData As Integer, ByVal nPage As Integer, ByRef lpInTextInfo As Byte, ByVal nCharNum As Integer) As Integer
    Private Declare Sub Image2PDFOCR_FreeTextHandle Lib "i2pocrsdk.dll" (ByVal hImage2PDFData As Integer)
    Private Declare Function Image2PDFOCR_CreatePDF Lib "i2pocrsdk.dll" (ByVal hImage2PDFData As Integer, ByVal lpszOutPDFFile As String, ByVal lpszOptions As String) As Integer
    Private Declare Function Image2PDFOCR_CreatePDFInMemory Lib "i2pocrsdk.dll" (ByVal hImage2PDFData As Integer, ByVal lpszOptions As String, ByRef lpDataBuf As Integer, ByRef nDataBufLen As Integer) As Integer
    Private Declare Function Image2PDFOCR_GetPageCount Lib "i2pocrsdk.dll" (ByVal lpszPDFFile As String) As Integer
    Private Declare Function Image2PDFOCR_GetWordCountOnPage Lib "i2pocrsdk.dll" (ByVal hImage2PDFData As Integer, ByVal nPage As Integer) As Integer
    Private Declare Function Image2PDFOCR_GetWordInfoByIndex Lib "i2pocrsdk.dll" (ByVal hImage2PDFData As Integer, ByVal nPage As Integer, ByVal nWordIndex As Integer, ByRef X As Integer, ByRef Y As Integer, ByRef Width As Integer, ByRef Height As Integer, ByRef lpText As Byte) As Integer
    Private Declare Function Image2PDFOCR_SetWordInfoByIndex Lib "i2pocrsdk.dll" (ByVal hImage2PDFData As Integer, ByVal nPage As Integer, ByVal nWordIndex As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal Width As Integer, ByVal Height As Integer, ByVal lpText As String) As Integer
    Private Declare Function Image2PDFOCR_ReadPDFFromMemory Lib "i2pocrsdk.dll" (ByVal hImage2PDFData As Integer, ByRef lpDataBuf As Byte, ByVal nDataBufLen As Integer) As Integer

    Public Structure TEXTPOSITION
        Public x As Integer
        Public y As Integer
        Public width As Integer
        Public height As Integer
        Public text() As Byte
        Sub init()
            ReDim text(500)
        End Sub
    End Structure

    Private Sub OCRPDFButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OCRPDFButton.Click
        Dim strOptions As String
        Dim strInFile As String
        Dim strOutFile As String
        Dim strLogMsg As String

        strInFile = Application.StartupPath() & "\test1.pdf"
        strOutFile = Application.StartupPath() & "\test1_vb_net_ocred.pdf"
        strOptions = "-pidpi 300"

        Dim nPageCount As Integer = Image2PDFOCR_GetPageCount(strInFile)
        strLogMsg = """" & strInFile & """ file contains """ & Str(nPageCount) & """ pages."
        MsgBox(strLogMsg)

        Dim hOCRTextSDK As Integer = Image2PDFOCR_GetTextHandle(strInFile, strOptions)
        If hOCRTextSDK <> 0 Then
            Dim nOCRedPageCount As Integer = Image2PDFOCR_GetOCRedPageCount(hOCRTextSDK)
            For page = 0 To nOCRedPageCount - 1
                Dim nWordCount As Integer = Image2PDFOCR_GetWordCountOnPage(hOCRTextSDK, page)
                For nWordIndex = 0 To nWordCount - 1
                    Dim nWord As TEXTPOSITION
                    nWord.init()
                    Image2PDFOCR_GetWordInfoByIndex(hOCRTextSDK, page, nWordIndex, nWord.x, nWord.y, nWord.width, nWord.height, nWord.text(0))
                    Dim enc As New System.Text.UTF8Encoding()
                    Dim strWord As String = enc.GetString(nWord.text)
                    Image2PDFOCR_SetWordInfoByIndex(hOCRTextSDK, page, nWordIndex, nWord.x, nWord.y, nWord.width, nWord.height, strWord)
                Next nWordIndex
            Next page

            Dim nDataBufLen As Integer = 0
            Dim nRet As Integer = Image2PDFOCR_CreatePDFInMemory(hOCRTextSDK, strOptions, 0, nDataBufLen)
            If nRet = 0 And nDataBufLen > 0 Then
                Dim vecFileData() As Byte = Nothing
                ReDim vecFileData(nDataBufLen)
                nRet = Image2PDFOCR_ReadPDFFromMemory(hOCRTextSDK, vecFileData(0), nDataBufLen)

                Dim oFileStream As System.IO.FileStream
                oFileStream = New System.IO.FileStream(strOutFile, System.IO.FileMode.Create)
                oFileStream.Write(vecFileData, 0, vecFileData.Length)
                oFileStream.Close()
            End If
            Image2PDFOCR_FreeTextHandle(hOCRTextSDK)
        End If
    End Sub
End Class
